// C++ STD
#include <iostream>
#include <stdlib.h>
using namespace std;
// SDL, OpenGL
#include <SDL.h>
//#include <SDL_image.h>
#include <GL/gl.h>
#include <GL/glu.h>
//#include <GL/glut.h>
// Avalanche
#include "object.hpp"
#include "aseObject.hpp"
#include "primitives.h"

/*********************************************************/
#define LARGEUR 800
#define HAUTEUR 600
#define ECRAN_BPP 24
//#define FULLSCREEN
#define FOV 45.0f
#define CODE_ERREUR 1
#define CODE_OK     0
#define PI 3.141592654


/*********************************************************/
// SDL, OpenGL
long temps;
SDL_Surface *surface=NULL;

// Avalanche
aseObject *laseobject;
GLuint lasetexture;
SDL_Surface *sdlasetexture;
#define LASE 1

/*********************************************************/
SDL_Surface *InitSDL()
{
  SDL_Surface *surface=NULL;
  const SDL_VideoInfo *videoInfo=NULL;

  // init
  int res=SDL_Init(SDL_INIT_VIDEO);

  if (res!=0)
    {
      cout<<"Couldn't INIT VIDEO\n";
      SDL_Quit();
    }

  // capacit hardware
  videoInfo=SDL_GetVideoInfo();
  
  if (!videoInfo)
    {
      cout<<"Couldn't get VideoInfo\n";
      SDL_Quit();
    }

  int videoParams=SDL_OPENGL|SDL_GL_DOUBLEBUFFER|SDL_HWPALETTE;

  #ifdef FULLSCREEN
  videoParams|=SDL_FULLSCREEN;
  #endif

  videoParams|=((videoInfo->hw_available)?SDL_HWSURFACE:SDL_SWSURFACE);

  if (videoInfo->blit_hw)
      videoParams|=SDL_HWACCEL;

  SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER,1);

  surface=SDL_SetVideoMode(LARGEUR,HAUTEUR,ECRAN_BPP,videoParams);

  if (!surface)
    {
      cout<<"Couldn't init surface\n";
      SDL_Quit();
    }

  return surface;
}


/*********************************************************/
void redimensionner(int largeur, int hauteur)
{
  largeur=max(largeur,1);
  hauteur=max(hauteur,1);

  GLfloat rapport=(GLfloat)largeur/(GLfloat)hauteur;

  glViewport(0,0,(GLint)largeur,(GLint)hauteur);  
  glMatrixMode(GL_PROJECTION);
  gluPerspective(FOV,rapport,0.1f,1000.0f);  
  glMatrixMode(GL_MODELVIEW);
}

void ViewOrtho(void)
{
  int largeur=max(LARGEUR,1);
  int hauteur=max(HAUTEUR,1);

  GLfloat rapport=(GLfloat)largeur/(GLfloat)hauteur;

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho( 0, LARGEUR , HAUTEUR , 0, -1, 1 );
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

void ViewPerspective()
{
  int largeur=max(LARGEUR,1);
  int hauteur=max(HAUTEUR,1);

  GLfloat rapport=(GLfloat)largeur/(GLfloat)hauteur;

  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective(FOV,rapport,0.1f,1000.0f);  
  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
}


/*********************************************************/
void drawGL_Repere(void)
{
  glPushMatrix();

  glScalef(1.0f,1.0f,1.0f);
  
  glBegin(GL_LINES);

  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(0.0f,0.0f,0.0f);
  glVertex3f(1.0f,0.0f,0.0f);

  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(0.0f,0.0f,0.0f);
  glVertex3f(0.0f,1.0f,0.0f);

  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(0.0f,0.0f,0.0f);
  glVertex3f(0.0f,0.0f,1.0f);

  glEnd();

  glPopMatrix();
}
void drawGL_ase(void)
{
  Vertex v1,v2,v3;
  TVertex tv1,tv2,tv3;

  int i,j=laseobject->get_nb_faces();

  map<const int, Face>::iterator it2=laseobject->Faces.begin();
  
  /*
  map<const int, TFace>::iterator it3=laseobject->TFaces.begin();

  glEnable(GL_TEXTURE_2D);
  glEnable(GL_SMOOTH);

  glBindTexture(GL_TEXTURE_2D,lasetexture);

  // texture
  glBegin(GL_TRIANGLES);
  for (i=0;i<j;i++)
  {
    v1=laseobject->get_vertex((*it2).second.coord[0]);
    v2=laseobject->get_vertex((*it2).second.coord[1]);
    v3=laseobject->get_vertex((*it2).second.coord[2]);

    tv1=laseobject->get_tvertex((*it3).second.coord[0]);
    tv2=laseobject->get_tvertex((*it3).second.coord[1]);
    tv3=laseobject->get_tvertex((*it3).second.coord[2]);

    glTexCoord2f(tv1.coord[0],tv1.coord[1]);
    glVertex3f(v1.coord[0],v1.coord[1],v1.coord[2]);
    cout<<

    glTexCoord2f(tv2.coord[0],tv2.coord[1]);
    glVertex3f(v2.coord[0],v2.coord[1],v2.coord[2]);
    
    glTexCoord2f(tv3.coord[0],tv3.coord[1]);
    glVertex3f(v3.coord[0],v3.coord[1],v3.coord[2]);

    it2++;
    it3++;
  }
  glEnd();
  */

  // Wireframe
  
  glColor3f(1.0f,1.0f,1.0f);
  glBegin(GL_LINES);
  for (i=0;i<j;i++)
  {
    v1=laseobject->get_vertex((*it2).second.coord[0]);
    v2=laseobject->get_vertex((*it2).second.coord[1]);
    v3=laseobject->get_vertex((*it2).second.coord[2]);

    glVertex3f(v1.coord[0],v1.coord[1],v1.coord[2]);
    glVertex3f(v2.coord[0],v2.coord[1],v2.coord[2]);

    glVertex3f(v2.coord[0],v2.coord[1],v2.coord[2]);
    glVertex3f(v3.coord[0],v3.coord[1],v3.coord[2]);

    glVertex3f(v3.coord[0],v3.coord[1],v3.coord[2]);
    glVertex3f(v1.coord[0],v1.coord[1],v1.coord[2]);

    it2++;
  }
  glEnd();
  

  // surfaces pleines
  /*
  glBegin(GL_TRIANGLES);
  for (i=0;i<j;i++)
  {
    v1=laseobject->get_vertex((*it2).second.coord[0]);
    v2=laseobject->get_vertex((*it2).second.coord[1]);
    v3=laseobject->get_vertex((*it2).second.coord[2]);

    glVertex3f(v1.coord[0],v1.coord[1],v1.coord[2]);
    glVertex3f(v2.coord[0],v2.coord[1],v2.coord[2]);
    glVertex3f(v3.coord[0],v3.coord[1],v3.coord[2]);

    it2++;
  }
  glEnd();
  */

  glEndList();
}


/*********************************************************/
int main(int argc, char *argv[])
{
  int fini=1;
  int frames=0;
  long tempsDebut=SDL_GetTicks();
  float fps=0.0f;
  SDL_Event evenement;
  int angle=0;

  // linux
  //laseobject=new aseObject("./statue.ase");
  // windows
  laseobject=new aseObject(".\\statue.ase");

  //  laseobject->test();
  /*
  cout<<"Load texture";
  glGenTextures (1, &lasetexture);
  glBindTexture (GL_TEXTURE_2D, lasetexture);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  sdlasetexture=IMG_Load("./media/sphere.png");
  glTexImage2D (GL_TEXTURE_2D, 0, GL_RGBA, sdlasetexture->w, sdlasetexture->h, 0, GL_RGBA, GL_UNSIGNED_BYTE, sdlasetexture->pixels);  
  cout<<"\n";
  */

  surface=InitSDL();
  
  redimensionner(LARGEUR,HAUTEUR);
  
  while(fini!=0)
    {
      temps=SDL_GetTicks();
      frames++;
      
      while(SDL_PollEvent(&evenement))
	{
	  switch(evenement.type)
	    {
	    case SDL_KEYDOWN:
	      if (evenement.key.keysym.sym==SDLK_ESCAPE)
		fini=0;
	      break;
	    case SDL_QUIT:
	      fini=0;
	      break;
	    default:
	      break;
	    }
	}
      
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

      // Affichage de la 3d
      ViewPerspective();
      glEnable(GL_DEPTH_TEST);
      
      glTranslatef(0.0f,0.0f,-15.0f);
      glRotatef(angle,0.0f,1.0f,0.0f);

      angle+=1;
      if (angle>360) angle=0;

      drawGL_Repere();
      drawGL_ase();


      if(SDL_GetTicks()-tempsDebut>1000)
	{
	  fps=1000.0f * (float)frames/(float)(SDL_GetTicks()-tempsDebut);
	  frames=0;
      
	  tempsDebut=SDL_GetTicks();
      
	  cout<<fps<<" fps\n";
	}

      SDL_GL_SwapBuffers();
    }

  laseobject->~aseObject();
  SDL_Quit();
  
  return CODE_OK;
}
